from tkinter import *
import random,math,time
random.seed(12345) # 完全に乱数にするには, この行をコメントに
Method=3 # 0:等方的, 1:一様乱数, 2:正規分布, 3:レヴィー分布 
Pace=10
def Levy():#レヴィー分布
    x=random.random()*10  # レヴィー分布のときの分布係数=10
    if abs(x)<0.00001:return 0
    c=0.5
    A=math.sqrt(c/(2*math.pi))
    return A*math.exp(-c/(2*x))/(math.pow(x,1.5))
#def nomalD():#正規分布(正規分布の乱数を発生させる方法)
#    T=-6
#    for i in range(12):T+=random.random()
#    return T
def nomalD():#正規分布(レヴィー分布と対等になるよう調整)
    x=random.random()*10
    A=math.sqrt(1/(2*math.pi))
    return A*math.exp(-x*x/2)
def uniWalk(x, y,Pace=0,Method=0):#ランダム・ウォーク
    th=random.random()*2.0*math.pi
    if   Method==0: DH=Pace                  #等方的
    elif Method==1: DH=2*Pace*random.random()#一様乱数
    elif Method==2: DH=nomalD()*Pace*8       #正規分布
    else          : DH=Levy()*Pace*5         #Levy分布
    return [x+DH*math.cos(th),y+DH*math.sin(th)]
#--------以下, メイン・プログラム-------------------
root=Tk();root.title("Random Walk")
canvas=Canvas(root,width=400,height=400,bg="white")
canvas.pack();x0=200.0; y0=200.0
x1=x0; y1=y0
for i in range(100):
    R=uniWalk(x1,y1,Pace,Method);x2=R[0];y2=R[1]
    canvas.create_line(x1,y1,x2,y2,fill="red",width=2)
    x1=x2;y1=y2
canvas.create_rectangle(x0-2,y0-2,x0+2,y0+2,fill="yellow")
canvas.create_rectangle(x1-2,y1-2,x1+2,y1+2,fill="green")



